implementation class
Sequence: Element

end;

implementation instance
Sequence
{
  <doc> The elements in this sequence.  </doc>
  MutableArray elements;
}

<doc> Designated initializer.  </doc>
id
  init
{
  elements = [MutableObjectArray new];
  = [super init];
}

<doc> Forward to the {elements}.  </doc>
void
  add Element object
{
  [elements add object];
} 

void
  checkLL1
{
  int i, n = [elements length];

  for (i = 0; i < n; i++)
    [elements[i] checkLL1];
}

OutputStream
  compile OutputStream s
{
  int i, n = [elements length];

  for (i = 0; i < n; i++)
    s = [elements[i] compile s];

  = s;
}

IntegerRangeSet
  computeLA IntegerRangeSet f
{
  if (run == current_run && follow != nil && [follow equal f])
    return la;
  run = current_run;

  follow = la = f;

  int i, n = [elements length];
  for (i = n - 1; i >= 0; i--)
    la = [elements[i] computeLA la];

  IntegerRangeSet next = [IntegerRangeSet new];
  for (i = 0; i < n; i++)
    {
      IntegerRangeSet nf = [elements[i] first];

      if (nf != nil)
	{
	  [next uniteWith nf];
	  if (![nf member EPSILON])
	    {
	      [next remove EPSILON];
	      break;
	    }
	}
    }

  if (!first || ![first equal next])
    {
      changes = YES;
      first = next;
    }

  = la;
}

OutputStream (s)
  describe-flat-rule OutputStream s
{
  int i, n = [elements length];
  for (i = 0; i < n; i++)
    {
      if (i > 0)
	[s print ' '];
      Element sym = elements[i];
      if (!sym)
	[s print "**nil**"];
      else
	[sym describe-flat-rule s];
    }
}

Element
  makeFlatRules String lhs_name
{
  Sequence result = [[Sequence alloc] init];
  int i, n = [elements length];

  for (i = 0; i < n; i++)
    {
      Element s = elements[i];
      [result add [s makeFlatRules nil]];
    }

  = result;
}

<doc> Compute the cost of this sequence, by adding the costs of the
    elements.  </doc>
int
  cost
{
  int sum, i, n = [elements length];

  for (i = 0; i < n; i++)
    {
      int c = [elements[i] cost];

      if (c == -1)
	return -1;

      sum += c;
    }

  = sum;
}

end;
